package com.unitesk.reqcoverage.tests;

import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import com.unitesk.requality.core.TreeDB;
import com.unitesk.requality.core.TreeNode;
import com.unitesk.requality.eclipse.core.TreesTracker;
import com.unitesk.requality.nodetypes.Requirement;
import com.unitesk.requality.nodetypes.TestPurpose;
import com.unitesk.requality.tests.CoverageStorage;
import com.unitesk.requality.tests.ICoverageSourceWizard;
import com.unitesk.requality.tests.ICoverageStorageSource;
import com.unitesk.requality.tests.TestErrorInfo;
import com.unitesk.requality.tests.TreeNodeCoverageInfo;

public class CoverageByTestPurposes implements ICoverageStorageSource {
	public static final String ID = "com.unitesk.reqcoverage.byTestPurposes";
	private String lastErrors;
	private CoverageStorage targetCoverageStorage;
	public CoverageByTestPurposes(){
		
	}
	
	@Override
	public Map<String, TreeNodeCoverageInfo> getCoverage() {
		lastErrors = "";
		Map<String, TreeNodeCoverageInfo> res = new HashMap<String, TreeNodeCoverageInfo>();
		TreeDB db = targetCoverageStorage.getTreeDB();
		recAdd(res,db.getNode(Requirement.getTypeRootQId()));
		return res;
	}
	private void recAdd(Map<String, TreeNodeCoverageInfo> res, TreeNode node) {
		if(node == null)
			return;
		TreeNode[] arr = node.getSortedChildren(TestPurpose.TYPE_NAME);
		int sc = node.sizeChildren();
		TreeNodeCoverageInfo tnci = new TreeNodeCoverageInfo();
		tnci.setTarget(node.getQualifiedId());
		for(int i = 0;i<sc;i++){
			TreeNode nde = node.getChild(i);
			if(TestPurpose.TYPE_NAME.equals(nde.getType())){
				tnci.registerTest(nde.getQualifiedId(),1);
				TreeNodeCoverageInfo tncit = new TreeNodeCoverageInfo();
				tncit.setTarget(nde.getQualifiedId());
				tncit.registerTest(nde.getQualifiedId(),1);
				res.put(nde.getQualifiedId(), tncit);
			}else if(Requirement.TYPE_NAME.equals(nde.getType())){
				recAdd(res, nde);
			}
		}
		if(tnci.getCntAll()>0)
			res.put(node.getQualifiedId(), tnci);
	}

	@Override
	public void setSettings(String... setts) {
		
	}
	@Override
	public String getLastErrors() {
		return lastErrors;
	}
	@Override
	public String[] getSettings(TreeNode node) {
		return new String[0];
	}
	@Override
	public Map<String, TestErrorInfo[]> getErrors() {
		return new HashMap<String, TestErrorInfo[]>();
	}
	@Override
	public void setTargetStorage(CoverageStorage coverageStorage) {
		targetCoverageStorage = coverageStorage;
	}
	@Override
	public ICoverageSourceWizard getWizard(TreeNode db) {
		return null;
	}

	@Override
	public Object getSourceObject(TreeDB db,Map<String, Object> node) {
		return new File(TreesTracker.getTracker().getProject(db).getLocation().toOSString());
	}

}
